import java.util.*;
public class DatenGA// implements IDatenGA
{
 public DatenGA (int codelaenge, IKreuzung k, IMutation m){
     this.codelaenge = codelaenge;
     adjMatrix = new int[codelaenge][codelaenge];
     x = new int[codelaenge];
     y = new int[codelaenge];
     //werte = new int[codelaenge];
     kreuzungsverfahren = k;
     mutationsverfahren = m;
     initialisiereMatrix();
 }
 //-------------- notwendige vom Interface geforderte Implementationen ---------
     public int fitnesswert(Individuum genCode){
        int wert = 0;
        for (int k=0; k<codelaenge; k++){
            int gen1 = genCode.getGen(k);
            int kk=(k+1)%codelaenge;
            int gen2 = genCode.getGen(kk);
            wert = wert + adjMatrix[gen1][gen2];
        }//for
        return wert;
    }
    
    public boolean istBesser(Individuum c1, Individuum c2){
      return fitnesswert(c1) <= fitnesswert(c2);
    }
    
    public String toString(){
      String s = "";
      for (int k=0; k<codelaenge; k++){
         for (int j=0; j<codelaenge; j++){
          s=s+adjMatrix[k][j]+"\t";
         }
         s=s+"\n";
      }
      return s;
    }
    
    public Paar kreuzung( Individuum c1, Individuum c2){
       return kreuzungsverfahren.kreuzung(c1, c2);
    }

     public void mutiere( Individuum c){
        mutationsverfahren.mutiere(c);
     }
     
     public void setKreuzung (IKreuzung k){
       kreuzungsverfahren=k;
     }
    
     public void setMutation (IMutation m){
       mutationsverfahren=m;
     }
     
     public void setCodelaenge(int i){
        codelaenge=i;
        adjMatrix = new int[codelaenge][codelaenge];
        x = new int[codelaenge];
        y = new int[codelaenge];
        initialisiereMatrix();
     }
     
    public void initZufllig(Individuum i){
    int lnge=i.getCodelnge();
    for (int k=lnge-1; k >=0; k--){
      i.setGen(k,k);
    }
    for (int k=lnge-1; k >=0; k--){
      int rnd = (int)(Math.random()*k);
      int h = i.getGen(rnd);
      i.setGen(rnd,i.getGen(k));
      i.setGen(k,h);
    }
  }
 
 
 // -----------zustzliche Methoden zur exakten Auswertung ---------
 public int[][] getAdjMatrix(){
   return adjMatrix;
 }
 
 public int[] getX(){
   return x;
 }
 
 public int[] getY(){
   return y;
 }
 
 public int getCodelaenge(){
   return codelaenge;
 }
 
 public void lade(DatenGA d){
  if(codelaenge==d.getCodelaenge()){
    for (int k =0 ; k<codelaenge ;k++  ) {
   x[k]=d.x[k];
   y[k]=d.y[k];
   for ( int j=0 ; j<codelaenge  ; j++ ) {
     adjMatrix[k][j] = d.adjMatrix[k][j];
   }
  }
 } //if codelaege
}
 //------------ Hilfroutinen --------------------------------------

  private void initialisiereMatrix(){
    for (int k=0  ;k< codelaenge  ; k++ ) {
       int rnd;
       rnd = (int) (Math.random()*290+5);
       x[k] = rnd;
       rnd = (int) (Math.random()*270+25);
       y[k] = rnd;
    }
    for (int k=0  ;k< codelaenge  ; k++ ) {
       for ( int j=k  ;j< codelaenge  ; j++ ) {
         if(k==j) {
           adjMatrix[k][j]=0;
         }
         else {
           int dx=x[k]-x[j];
           int dy=y[k]-y[j];
           double d = Math.sqrt(dx*dx+dy*dy);
           adjMatrix[k][j] = (int) (d);
           adjMatrix[j][k]= adjMatrix[k][j];
         }
       }
    }
  }
 //------------Attribute ------------------------------------------

    //private int[] werte;
    private int[][] adjMatrix;
    private int[] x;
    private int[] y;
    private int codelaenge;
    private IKreuzung kreuzungsverfahren;
    private IMutation mutationsverfahren;
    //boolean[] menge;
}

